<?php

// PukiWiki - Yet another WikiWikiWeb clone.
// $Id: init.php,v 1.57 2011/01/25 15:01:01 henoheno Exp $
// Copyright (C)
//   2002-2007, 2009, 2011 PukiWiki Developers Team
//   2001-2002 Originally written by yu-ji
// License: GPL v2 or (at your option) any later version
//
// Init PukiWiki here
/**/

// PukiWiki version / Copyright / Licence
/**/


define('S_VERSION', '1.4.8-dev-b3');
define('S_CORE_LICENSE',' License is <a href="http://www.gnu.org/licenses/gpl.html">GPL</a>.');
define('S_CORE_BASED_ON', ' Based On ' .
        'PukiWiki 1.4.8 Copyright &copy; 2001-2011' .
        ' <a href="http://pukiwiki.sourceforge.jp/">PukiWiki Developers Team</a>.' .
        ' "PukiWiki" 1.3 by <a href="http://factage.com/yu-ji/">yu-ji</a>'
       );
define('S_COPYRIGHT', ' Powered by ' .
        '<a href="http://popowiki.sourceforge.jp/"><strong>' .
        'PopoWiki ' . HtmlUtils::escapeHTML(((defined('HIDE_VERSION_STRING') && HIDE_VERSION_STRING ) ? '' : S_VERSION), ENT_QUOTES) .
        '</strong></a>' .  '&copy; 2014 ' .
        "<br />\n " . S_CORE_BASED_ON . "<br /> \n" . S_CORE_LICENSE
        );

// UTF8:
if ( !defined('PKWK_UTF8_ENABLE') )
    define('PKWK_UTF8_ENABLE', 1);

/////////////////////////////////////////////////
// Init server variables
// Comapat and suppress notices
if ( !isset($HTTP_SERVER_VARS) )
    $HTTP_SERVER_VARS = array();

foreach ( array('SCRIPT_NAME', 'SERVER_ADMIN', 'SERVER_NAME',
 'SERVER_PORT', 'SERVER_SOFTWARE') as $key )
{
    define($key, isset($_SERVER[$key]) ? $_SERVER[$key] : '');
    unset(${$key}, $_SERVER[$key], $HTTP_SERVER_VARS[$key]);
}

/////////////////////////////////////////////////
// Init grobal variables

$foot_explain = array(); // Footnotes
$related = array(); // Related pages
$head_tags = array(); // XHTML tags in <head></head>

$load_plugin_list = array( '^\w{1,64}$'   );
$non_plugin_list  = array( '^(tb|paint)$' );

/////////////////////////////////////////////////
// Time settings

define('LOCALZONE', date('Z'));
define('UTIME', time() - LOCALZONE);
define('MUTIME', getmicrotime());

/////////////////////////////////////////////////
// Require INI_FILE

define('INI_FILE', SETTINGS_DIR . 'pukiwiki.ini.php');
$die = '';
if ( !file_exists(INI_FILE) || !is_readable(INI_FILE) )
{
    $die .= 'File is not found. (INI_FILE)' . "\n";
}
else
{
    require(INI_FILE);
}
if ( $die )
    die_message(nl2br("\n\n" . $die));

/////////////////////////////////////////////////
// INI_FILE: LANG に基づくエンコーディング設定
// MB_LANGUAGE: mb_language (for mbstring extension)
//   'uni'(means UTF-8), 'English', or 'Japanese'
// SOURCE_ENCODING: Internal content encoding (for mbstring extension)
//   'UTF-8', 'ASCII', or 'EUC-JP'
// CONTENT_CHARSET: Internal content encoding = Output content charset
//    (for DTD, HtmlUtils::escapeHTML())
//   'UTF-8', 'iso-8859-1', 'EUC-JP' or ...

switch ( LANG )
{
    case 'en': define('MB_LANGUAGE', 'English');
        break;
    case 'ja': define('MB_LANGUAGE', 'Japanese');
        break;
//UTF-8:case 'ko': define('MB_LANGUAGE', 'Korean'  ); break;
//UTF-8:	// See [[pukiwiki.dev:BugTrack2/13]] for all hack about Korean support,
//UTF-8:	// and give us your report!
    default: die_message('No such language "' . LANG . '"');
        break;
}

//UTF-8:define('PKWK_UTF8_ENABLE', 1);
if ( defined('PKWK_UTF8_ENABLE') )
{
    define('SOURCE_ENCODING', 'UTF-8');
    define('CONTENT_CHARSET', 'UTF-8');
}
else
{
    switch ( LANG )
    {
        case 'en':
            define('SOURCE_ENCODING', 'ASCII');
            define('CONTENT_CHARSET', 'iso-8859-1');
            break;
        case 'ja':
            define('SOURCE_ENCODING', 'EUC-JP');
            define('CONTENT_CHARSET', 'EUC-JP');
            break;
    }
}

mb_language(MB_LANGUAGE);
mb_internal_encoding(SOURCE_ENCODING);
ini_set('mbstring.http_input', 'pass');
mb_http_output('pass');
mb_detect_order('auto');

/////////////////////////////////////////////////
// INI_FILE: Require LANG_FILE
if ( !defined('LANG_FILE_DIR') )
    define('LANG_FILE_DIR', LIB_DIR . 'languages/'); // moved from DATA_HOME

define('LANG_FILE_HINT', LANG_FILE_DIR . LANG . '.lng.php'); // For encoding hint
define('LANG_FILE', LANG_FILE_DIR . UI_LANG . '.lng.php'); // For UI resource
$die = '';
foreach ( array('LANG_FILE_HINT', 'LANG_FILE') as $langfile )
{
    if ( !file_exists(constant($langfile)) || !is_readable(constant($langfile)) )
    {
        $die .= 'File is not found or not readable. (' . $langfile . ')' . "\n";
    }
    else
    {
        require_once(constant($langfile));
    }
}
if ( $die )
    die_message(nl2br("\n\n" . $die));

/////////////////////////////////////////////////
// LANG_FILE: Init encoding hint

define('PKWK_ENCODING_HINT', isset($_LANG['encode_hint'][LANG]) ? $_LANG['encode_hint'][LANG] : '');
unset($_LANG['encode_hint']);

/////////////////////////////////////////////////
// LANG_FILE: Init severn days of the week

$weeklabels = $_msg_week;

/////////////////////////////////////////////////
// INI_FILE: Init $script

if ( isset($script) )
{
    get_script_uri($script); // Init manually
}
else
{
    $script = get_script_uri(); // Init automatically
}

/////////////////////////////////////////////////
// INI_FILE: $agents:  UserAgentの識別

$ua = 'HTTP_USER_AGENT';
$user_agent = $matches = array();

$user_agent['agent'] = isset($_SERVER['HTTP_USER_AGENT']) ? $_SERVER['HTTP_USER_AGENT'] : '';
unset(${$ua}, $_SERVER[$ua], $HTTP_SERVER_VARS[$ua], $ua); // safety

foreach ( $agents as $agent )
{
    if ( preg_match($agent['pattern'], $user_agent['agent'], $matches) )
    {
        $user_agent['profile'] = isset($agent['profile']) ? $agent['profile'] : '';
        $user_agent['name'] = isset($matches[1]) ? $matches[1] : ''; // device or browser name
        $user_agent['vers'] = isset($matches[2]) ? $matches[2] : ''; // 's version
        break;
    }
}
unset($agents, $matches);

// Profile-related init and setting
define('UA_PROFILE', isset($user_agent['profile']) ? $user_agent['profile'] : '');

define('UA_INI_FILE', SETTINGS_DIR . UA_PROFILE . '.ini.php');
if ( !file_exists(UA_INI_FILE) || !is_readable(UA_INI_FILE) )
{
    die_message('UA_INI_FILE for "' . UA_PROFILE . '" not found.');
}
else
{
    require(UA_INI_FILE); // Also manually
}

define('UA_NAME', isset($user_agent['name']) ? $user_agent['name'] : '');
define('UA_VERS', isset($user_agent['vers']) ? $user_agent['vers'] : '');
unset($user_agent); // Unset after reading UA_INI_FILE
/////////////////////////////////////////////////
// ディレクトリのチェック

$die = '';
foreach ( array('DATA_DIR', 'DIFF_DIR', 'BACKUP_DIR', 'CACHE_DIR') as $dir )
{
    if ( !is_writable(constant($dir)) )
        $die .= 'Directory is not found or not writable (' . $dir . ')' . "\n";
}

// 設定ファイルの変数チェック
$temp = '';
foreach ( array('rss_max', 'page_title', 'note_hr', 'related_link', 'show_passage',
 'rule_related_str', 'load_template_func') as $var )
{
    if ( !isset(${$var}) )
        $temp .= '$' . $var . "\n";
}
if ( $temp )
{
    if ( $die )
        $die .= "\n"; // A breath
    $die .= 'Variable(s) not found: (Maybe the old *.ini.php?)' . "\n" . $temp;
}

$temp = '';
foreach ( array('LANG', 'PLUGIN_DIR') as $def )
{
    if ( !defined($def) )
        $temp .= $def . "\n";
}
if ( $temp )
{
    if ( $die )
        $die .= "\n"; // A breath
    $die .= 'Define(s) not found: (Maybe the old *.ini.php?)' . "\n" . $temp;
}

if ( $die )
    die_message(nl2br("\n\n" . $die));
unset($die, $temp);

/////////////////////////////////////////////////
// 必須のページが存在しなければ、空のファイルを作成する

foreach ( array($defaultpage, $whatsnew, $interwiki) as $page )
{
    if ( !is_page($page) )
        pkwk_touch_file(get_filename($page));
}

/////////////////////////////////////////////////
// 外部からくる変数のチェック
// Prohibit $_GET attack
foreach ( array('msg', 'pass') as $key )
{
    if ( isset($_GET[$key]) )
        die_message('Sorry, already reserved: ' . $key . '=');
}

// Expire risk
unset($HTTP_GET_VARS, $HTTP_POST_VARS); //, 'SERVER', 'ENV', 'SESSION', ...
unset($_REQUEST); // Considered harmful
// Remove null character etc.
$_GET = input_filter($_GET);
$_POST = input_filter($_POST);
$_COOKIE = input_filter($_COOKIE);

// 文字コード変換 ($_POST)
// <form> で送信された文字 (ブラウザがエンコードしたデータ) のコードを変換
// POST method は常に form 経由なので、必ず変換する
//
if ( isset($_POST['encode_hint']) && $_POST['encode_hint'] != '' )
{
    // do_plugin_xxx() の中で、<form> に encode_hint を仕込んでいるので、
    // encode_hint を用いてコード検出する。
    // 全体を見てコード検出すると、機種依存文字や、妙なバイナリ
    // コードが混入した場合に、コード検出に失敗する恐れがある。
    $encode = mb_detect_encoding($_POST['encode_hint']);
    mb_convert_variables(SOURCE_ENCODING, $encode, $_POST);
}
else if ( isset($_POST['charset']) && $_POST['charset'] != '' )
{
    // TrackBack Ping で指定されていることがある
    // うまくいかない場合は自動検出に切り替え
    if ( mb_convert_variables(SOURCE_ENCODING, $_POST['charset'], $_POST) !== $_POST['charset'] )
    {
        mb_convert_variables(SOURCE_ENCODING, 'auto', $_POST);
    }
}
else if ( !empty($_POST) )
{
    // 全部まとめて、自動検出／変換
    mb_convert_variables(SOURCE_ENCODING, 'auto', $_POST);
}

// 文字コード変換 ($_GET)
// GET method は form からの場合と、<a href="http://script/?key=value> の場合がある
// <a href...> の場合は、サーバーが rawurlencode しているので、コード変換は不要
if ( isset($_GET['encode_hint']) && $_GET['encode_hint'] != '' )
{
    // form 経由の場合は、ブラウザがエンコードしているので、コード検出・変換が必要。
    // encode_hint が含まれているはずなので、それを見て、コード検出した後、変換する。
    // 理由は、post と同様
    $encode = mb_detect_encoding($_GET['encode_hint']);
    mb_convert_variables(SOURCE_ENCODING, $encode, $_GET);
}


/////////////////////////////////////////////////
// QUERY_STRINGを取得

$arg = '';
if ( isset($_SERVER['QUERY_STRING']) && $_SERVER['QUERY_STRING'] != '' )
{
    $arg = & $_SERVER['QUERY_STRING'];
}
else if ( isset($_SERVER['argv']) && !empty($_SERVER['argv']) )
{
    $arg = & $_SERVER['argv'][0];
}
if ( PKWK_QUERY_STRING_MAX && strlen($arg) > PKWK_QUERY_STRING_MAX )
{
    // Something nasty attack?
    pkwk_common_headers();
    echo('Query string too long');
    exit;
}
$arg = input_filter($arg); // \0 除去
// unset QUERY_STRINGs
foreach ( array('QUERY_STRING', 'argv', 'argc') as $key )
{
    unset(${$key}, $_SERVER[$key], $HTTP_SERVER_VARS[$key]);
}
// $_SERVER['REQUEST_URI'] is used at func.php NOW
unset($REQUEST_URI, $HTTP_SERVER_VARS['REQUEST_URI']);

// mb_convert_variablesのバグ(?)対策: 配列で渡さないと落ちる
$arg = array($arg);
mb_convert_variables(SOURCE_ENCODING, 'auto', $arg);
$arg = $arg[0];

/////////////////////////////////////////////////
// QUERY_STRINGを分解してコード変換し、$_GET に上書き
// URI を urlencode せずに入力した場合に対処する
$matches = array();
foreach ( explode('&', $arg) as $key_and_value )
{
    if ( preg_match('/^([^=]+)=(.+)/', $key_and_value, $matches) &&
            mb_detect_encoding($matches[2]) != 'ASCII' )
    {
        $_GET[$matches[1]] = $matches[2];
    }
}
unset($matches);

/////////////////////////////////////////////////
// GET, POST, COOKIE

$get = & $_GET;
$post = & $_POST;
$cookie = & $_COOKIE;

// GET + POST = $vars
if ( empty($_POST) )
{
    $method = 'GET';
    $vars = & $_GET;  // Major pattern: Read-only access via GET
}
else if ( empty($_GET) )
{
    $method = 'POST';
    $vars = & $_POST; // Minor pattern: Write access via POST etc.
}
else
{
    $method = 'GET and POST';
    $vars = array_merge($_GET, $_POST); // Considered reliable than $_REQUEST
}

// 入力チェック: 'cmd=' and 'plugin=' can't live together
if ( isset($vars['cmd']) && isset($vars['plugin']) )
    die('Using both cmd= and plugin= is not allowed');

// 入力チェック: cmd, plugin の文字列は英数字以外ありえない
foreach ( array('cmd', 'plugin') as $var )
{
    if ( isset($vars[$var]) && !preg_match('/^[a-zA-Z][a-zA-Z0-9_]*$/', $vars[$var]) )
        unset($get[$var], $post[$var], $vars[$var]);
}

// 整形: page, strip_bracket()
if ( isset($vars['page']) )
{
    $get['page'] = $post['page'] = $vars['page'] = strip_bracket($vars['page']);
}
else
{
    $get['page'] = $post['page'] = $vars['page'] = '';
}

// 整形: msg, 改行を取り除く
if ( isset($vars['msg']) )
{
    $get['msg'] = $post['msg'] = $vars['msg'] = str_replace("\r", '', $vars['msg']);
}

// 後方互換性 (?md5=...)
if ( isset($get['md5']) && $get['md5'] != '' &&
        !isset($vars['cmd']) && !isset($vars['plugin']) )
{
    $get['cmd'] = $post['cmd'] = $vars['cmd'] = 'md5';
}

// cmdもpluginも指定されていない場合は、QUERY_STRINGをページ名かInterWikiNameであるとみなす
if ( !isset($vars['cmd']) && !isset($vars['plugin']) )
{

    $get['cmd'] = $post['cmd'] = $vars['cmd'] = 'read';

    if ( $arg == '' )
        $arg = $defaultpage;
    $arg = rawurldecode($arg);
    $arg = strip_bracket($arg);
    $arg = input_filter($arg);
    $get['page'] = $post['page'] = $vars['page'] = $arg;
}

/////////////////////////////////////////////////
// 初期設定($WikiName,$BracketNameなど)
// $WikiName = '[A-Z][a-z]+(?:[A-Z][a-z]+)+';
// $WikiName = '\b[A-Z][a-z]+(?:[A-Z][a-z]+)+\b';
// $WikiName = '(?<![[:alnum:]])(?:[[:upper:]][[:lower:]]+){2,}(?![[:alnum:]])';
// $WikiName = '(?<!\w)(?:[A-Z][a-z]+){2,}(?!\w)';
// [[pukiwiki.dev:BugTrack/304]]暫定対処
$WikiName = '(?:[A-Z][a-z]+){2,}(?!\w)';

// $BracketName = ':?[^\s\]#&<>":]+:?';
$BracketName = '(?!\s):?[^\r\n\t\f\[\]<>#&":]+:?(?<!\s)';

// InterWiki
$InterWikiName = '(\[\[)?((?:(?!\s|:|\]\]).)+):(.+)(?(1)\]\])';

// 注釈
$NotePattern = '/\(\(((?:(?>(?:(?!\(\()(?!\)\)(?:[^\)]|$)).)+)|(?R))*)\)\)/ex';

/////////////////////////////////////////////////
// 初期設定(ユーザ定義ルール読み込み)
require(SETTINGS_DIR . 'rules.ini.php');

/////////////////////////////////////////////////
// 初期設定(その他のグローバル変数)
// 現在時刻
$now = format_date(UTIME);

// 日時置換ルールを$line_rulesに加える
if ( $usedatetime )
    $line_rules += $datetime_rules;
unset($datetime_rules);

// フェイスマークを$line_rulesに加える
if ( $usefacemark )
    $line_rules += $facemark_rules;
unset($facemark_rules);

// 実体参照パターンおよびシステムで使用するパターンを$line_rulesに加える
//$entity_pattern = '[a-zA-Z0-9]{2,8}';
$entity_pattern = trim(join('', file(CACHE_DIR . PKWK_ENTITIES_REGEX_CACHE)));

$line_rules = array_merge(array(
    '&amp;(#[0-9]+|#x[0-9a-f]+|' . $entity_pattern . ');' => '&$1;',
    "\r" => '<br />' . "\n", /* 行末にチルダは改行 */
        ), $line_rules);

